--todo table.sort alphabetical voicelines list
--todo test ProcessBlacklist() errors

_G.AntiVoiceSpamTwo = AntiVoiceSpamTwo or {}
local AVS = AntiVoiceSpamTwo

AVS._path = ModPath
local old_save_name = "antivoicespam2.txt" --AVS2 v1.0 
local save_name = "antivoicespam2_v2.txt" --AVS2 v2.0 (yes i know that's confusing)
AVS._save_path = SavePath .. save_name

AVS._default_settings = {
	enabled = true,
	mute_all = false, --if true: NO voicelines whatsoever
	vo_preview = true, --if true, plays voiceline sample when selecting it in menu
	vo_cooldown = 0 --seconds between played voicelines from any given peer
}
AVS._settings = table.deep_map_copy(AVS._default_settings)

AVS._default_blacklist = { --most of these sounds are from the original Anti Voice Spam mod
	["play_pln_gen_count_17"] = true, --these ones are probably branch bank alarm noises
	["Play_pln_branchbank_stage1_83"] = true, --not sure if the capital "P" is a typo or not
	["play_pln_gen_urg_01"] = true,
	["play_pln_gen_dir_07"] = true,
	["play_pln_gen_dir_08"] = true,
	["diegetic_club_music"] = true, --club music
	["diegetic_club_rock_music"] = true, -- club music
	["diegetic_lounge_music"] = true, -- club music
	["cloaker_detect_mono"] = true, -- cloaker static
	["cloaker_presence_loop"] = true, --cloaker wolololololololo
	["cpa_a03_01"] = true, --KEEP EM OCCUPIED TIL THE TURRET GETS HERE
	["cpa_a02_01"] = true, --CAPTAIN'S GOT HERE, TIME TO TURN THIS AROUND
	["cpw_a04"] = true, --WINTERS: TACTICAL WITHDRAWAL
	["cpw_a05"] = true, --WINTERS: battle cry
	["cpa_a04_01"] = true, --GUYS, THE TURRET'S ARRIVED
	["bdz_entrance"] = true, 
	["bdz_entrance_elite"] = true, --DOZER IN THE HOUSE
	["bdz_x02a_any_3p"] = true, --dozer death noise
	["bdz_visor_lost"] = true,--YOU THINK THAT'S GONNA STOP ME
	["cloaker_detect_christmas_mono"] = true, --jingle bells (christmas cloaker wololo)
	["cloaker_taunt_after_assault"] = true, --STOP HITTING YOURSELF
	["alarmbomb"] = true,
	["camera_alarm_signal"] = true, --beeeeeeeeep
	["alarm_countdown_loop"] = true,
	["alarm_countdown_ticking_down_10sec"] = true,
	["alarm_fire"] = true,
	["alarm_kosugi_on_slow_fade"] = true,
	["alarm_museum_on_slow_fade"] = true,
	["alarm_the_bomb_on_slow_fade"] = true,
	["hitec_lotec_alarm_slow_fade"] = true,
	["jewelry_alarm_on_slow_fade"] = true,
	["swatturret_alert"] = true,
	["swat_explosion"] = true,
	["swat_blows_window_medium"] = true,
	["shield_identification"] = true,
	["c4_beep_loop"] = true, 
	["cm1_burndeath"] = true, --cop burn death
	["tsr_burndeath"] = true, --taser burn death 
	["tsr_x02a_any_3p"] = true, --taser death groan
	["clk_burndeath"] = true,
	["clk_x02a_any_3p"] = true,
	["santa_hoho"] = true,
	["criminals_ambition"] = true,
	["criminals_ambition_instrumental"] = true,
	["pth_criminal_intent"] = true,
	["goat_says_meh"] = true, -- G O Ts
	["goat_says_meh_loop"] = true,
	["goat_fan_woosh"] = true, 
	["goat_hang_scaffold"] = true,
	["goat_headbutt"] = true,
	["goat_kick"] = true,
	["goat_lick"] = true,
	["goat_sleep"] = true,
	["v34"] = false, --heat speech
	["v35"] = false, --BAIN!?
	["v55"] = true, --skydive screaming
	["g29"] = true, --(haha fuck lol)
	["g60"] = true, --(oh shit!)
	["whistling_attention"] = true --iirc only used in framing frame day 3 but loaded on all maps
}
AVS._blacklist = table.deep_map_copy(AVS._default_blacklist) --(readable) string ids

AVS._vo_cooldowns = {} --stores time (as float) of last voiceline per player, by steam id64 
AVS._internal_blacklist = nil --{} --raw event_ids 
AVS._preview_sound = nil --stores the sound event for currently playing vo preview

AVS.unsaved_data = false -- flag for whether or not to display "unsaved data" warning

function AVS:Load(skip_settings,skip_blacklist)
--	load_settings,load_blacklist = (((load_settings ~= nil) and (load_blacklist ~= nil)) and unpack({load_settings,load_blacklist})) or unpack({true,true})
	local old_file = io.open(SavePath .. old_save_name,"r")
	local file = io.open(AVS._save_path, "r")
	if (file) then
		local raw_save = json.decode(file:read("*all"))
		for save_cat, save_tbl in pairs(raw_save) do
			if not skip_settings and (save_cat == "settings") then 
--				self._settings = table.deep_map_copy(save_tbl) --don't overwrite settings table, in case i need to add more settings in an update and those settings are called immediately after load
				for I,II in pairs(save_tbl) do 
					self._settings[I] = II
				end
			elseif not skip_blacklist and (save_cat == "blacklist") then
--				self._blacklist = table.deep_map_copy(save_tbl) --same thing here
				for II,L in pairs(save_tbl) do 
					self._blacklist[II] = L
				end
			end
		end
	elseif (old_file) then --legacy save file support for Anti Voice Spam 2 (v1.0)
		log("[Anti Voice Spam] First launch or missing blacklist file. Generating new blacklist.")
		for string_id,enabled in pairs(json.decode(old_file:read("*all"))) do
			self._blacklist[string_id] = enabled
		end
		self:Save() --write data to AVS v2.0 new save format
	else
		self:Save() --create all new data if no save files found
	end
	self:ProcessBlacklist()	
end

function AVS:Save(show_success)
	self.unsaved_data = false
	local file = io.open(AVS._save_path,"w+")
	local save_settings = self._settings
	local save_blacklist = self._blacklist
	if file then
		file:write(json.encode({settings = save_settings,blacklist = save_blacklist}))
		file:close()
	end	
	if show_success then 
		local success_title = managers.localization:text("avs_success")
		local success_desc = managers.localization:text("avs_save_success_desc")
		local options = {
			{
				text = managers.localization:text("avs_done"),
				is_cancel_button = true
			}
		}
		QuickMenu:new(success_title,success_desc,options):show()
	end
	self:ProcessBlacklist() --probably not necessary here
end

function AVS:ProcessBlacklist(no_reset) --todo add this on game load
	if not no_reset then 
		self._internal_blacklist = {}
	end
	for string_id,enabled in pairs(self._blacklist) do 
		self._internal_blacklist[tostring(SoundDevice:string_to_id(string_id))] = enabled
	end
end

function AVS:Enabled()
	return self._settings.enabled
end

function AVS:IsMuteAll()
	return self._settings.mute_all
end

function AVS:GetVOCooldownSetting() --gets cooldown time between lines
	return self._settings.vo_cooldown
end

function AVS:GetPlayerVOCooldown(id) --gets time of last voiceline for this player
	if id and self._vo_cooldowns and not self._vo_cooldowns[id] then 
		self._vo_cooldowns[id] = Application:time()
	end
	return self._vo_cooldowns and self._vo_cooldowns[id or 0] or 0
end

function AVS:SetPlayerVOCooldown(id)
	self._vo_cooldowns[id or 0] = Application:time()
end

function AVS:IsMuted(peer)
	return self._settings.mute_all or ((not managers.chat) or managers.chat:is_peer_muted(peer))
end

function AVS:IsBannedByName(sound_name) --sound name (string)
	if not sound_name then return end
	return self._blacklist[sound_name]
end

function AVS:IsBanned(event_id) --event id (number)
	if not self._internal_blacklist then 
		self:ProcessBlacklist()
	end
	event_id = tostring(event_id or "nil")
	return self._internal_blacklist[event_id]
end

function AVS:OpenBlacklistDialogue(delet_this)
	local max_char_length = 64
	local clbk_func = delet_this and "RemoveBlacklistEntry" or "AddBlacklistEntry"
	if not QuickKeyboardInput then 
		local error_title = managers.localization:text("avs_error_missing_qki_title")
		local error_desc = managers.localization:text("avs_error_missing_qki_desc")
		QuickMenu:new(error_title,error_desc,{{text = "BOTTOM TEXT",is_cancel_button = true}}):show()
		return
	end
	local default_entry = ""
	local menu_title = managers.localization:text("avs_add_blacklist_voiceline_title")
	local menu_desc = managers.localization:text("avs_add_blacklist_voiceline_desc")
	QuickKeyboardInput:new(menu_title,menu_desc,default_entry,callback(self,self,clbk_func),max_char_length,true)
end

function AVS:RemoveBlacklistEntry(id)
	local title = "avs_success" --todo macro?
	local desc = "avs_del_blacklist_success_desc"
	if id then 
		id = tostring(id)
		
		if self._blacklist[id] == nil then 
			title = "avs_fail"
			desc = "avs_del_blacklist_fail_desc"
		else
			self.unsaved_data = true
		end
		self._blacklist[id] = nil
	end
	local options = {
		{
			text = managers.localization:text("avs_done"),
			callback = callback(self,self,"StopVOPreview")		
		}
	}
	
	QuickMenu:new(managers.localization:text(title),managers.localization:text(desc),options):show()
end

function AVS:AddBlacklistEntry(id)
	if id then 
		id = tostring(id)
		self._blacklist[id] = true
	end
	self:StartVOPreview(id)
	self.unsaved_data = true
	local success_title = managers.localization:text("avs_success") --todo macro?
	local success_desc = managers.localization:text("avs_add_blacklist_success_desc")
	local options = {
		{
			text = managers.localization:text("avs_done"),
			callback = callback(self,self,"StopVOPreview")		
		}
	}
	QuickMenu:new(success_title,success_desc,options):show()
end

function AVS:StartVOPreview(id)
	self:StopVOPreview()
	--[[
	if not self._sound_source then 
		self._sound_source = SoundDevice:create_source("AVS") 
	end
	local snd_src = self._sound_source 
	--]]
	local snd_src = managers.menu._sound_source --managers.menu_component._sound_source -- would work for in-game previews if menu noises would just stop overriding them.
	if self._settings.vo_preview then 
		if snd_src and id then
			if alive(snd_src) then
				self._preview_sound = snd_src:post_event(id)
			end
		end
	end
end

function AVS:StopVOPreview()
	if alive(self._preview_sound) then 
		self._preview_sound:stop()
	end
	self._preview_sound = false
end

function AVS:ToggleVoiceline(params)
	if not (params and params.id) then 
		log("AntiVoiceSpam: Bad data to ToggleVoiceline()! Aborting customization menu...")
		return 	
	end
	local id = params.id
	local page = params.page
	local enabled = not self._blacklist[id]
	if params.enabled ~= nil then 
		enabled = not params.enabled
	end
	self._blacklist[id] = enabled
	self.unsaved_data = true
	self:StartVOPreview(id)
	self:OpenBlacklistSwitchboard(page)
end

function AVS:OpenBlacklistSwitchboard(page)
	page = page or 1
	local max_entries_per_page = 20
	--local total_entries = #self._blacklist
	local total_entries = 0
	for k,v in pairs(self._blacklist) do 
		total_entries = total_entries + 1
	end
	
	local i = 0
	local total_entries_shown = 0
	local options = {}
	for string_id,enabled in pairs(self._blacklist) do
		if (total_entries_shown < max_entries_per_page) and (i >= ((page - 1) * max_entries_per_page)) then 
			table.insert(options,{
				text = tostring(string_id) .. tostring(enabled and " [off]" or " [on]"), --todo macro
				callback = callback(self,self,"ToggleVoiceline",{id = string_id,enabled = enabled,page = page})
			})
			total_entries_shown = total_entries_shown + 1
		end
		i = i + 1
	end
	
	if total_entries - (((page - 1) * max_entries_per_page) + total_entries_shown) > 0 then  --broken
		table.insert(options,{
			text = managers.localization:text("avs_next_page"),
			callback = callback(self,self,"OpenBlacklistSwitchboard",page+1)
		})
	end
	if page > 1 then 
		table.insert(options,{
			text = managers.localization:text("avs_prev_page"),
			callback = callback(self,self,"OpenBlacklistSwitchboard",page-1)
		})
	end
	table.insert(options,{
		text = managers.localization:text("avs_done"),
		callback = callback(self,self,"StopVOPreview")
	})
	local menu_title =  managers.localization:text("avs_switchboard_title")
	local menu_desc =  managers.localization:text("avs_switchboard_desc")
	QuickMenu:new(menu_title,menu_desc,options):show()
end

function AVS:ShowUnsavedDialogue()
	self:StopVOPreview()
	local menu_title = managers.localization:text("avs_warning_unsaved_title")
	local menu_desc = managers.localization:text("avs_warning_unsaved_desc")
	local options = {
		{
			text = managers.localization:text("avs_unsaved_discard"),
			callback = callback(self,self,"Load")
		},
		{
			text = managers.localization:text("avs_unsaved_keep"),
			callback = callback(self,self,"Save",true)
		},
		{
			text = managers.localization:text("avs_unsaved_try"),
			is_cancel_button = true,
		}
	}
	QuickMenu:new(menu_title,menu_desc,options):show()
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_avs2", function( loc )
	loc:load_localization_file( AVS._path .. "en.txt")
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_avs2", function(menu_manager)
	MenuCallbackHandler.callback_avs_masterenable = function(self,item)
		local on = item:value() == "on"
		AVS._settings.enabled = on
	end

	MenuCallbackHandler.callback_avs_muteall = function(self,item)
		local on = item:value() == "on"
		AVS._settings.mute_all = on
	end

	MenuCallbackHandler.callback_avs_vopreview = function(self,item)
		AVS._settings.vo_preview = item:value()
		AVS.unsaved_data = true
	end
	
	MenuCallbackHandler.callback_avs_delblacklist = function(self,item)
		AVS:OpenBlacklistDialogue(true)
	end
	
	MenuCallbackHandler.callback_avs_editblacklist = function(self,item)
		AVS:OpenBlacklistSwitchboard(1)
	end
	
	MenuCallbackHandler.callback_avs_addblacklist = function(self,item)
		AVS:OpenBlacklistDialogue(false)
	end
	
	MenuCallbackHandler.callback_avs_setvocooldown = function(self,item)
		AVS._settings.vo_cooldown = item:value()
		AVS.unsaved_data = true
	end
	MenuCallbackHandler.callback_avs_close = function(self)
		if AVS.unsaved_data then 
			AVS:ProcessBlacklist()
			AVS:ShowUnsavedDialogue()
		end
	end
	MenuCallbackHandler.callback_avs_save = function(self)
		AVS:Save()
	end
	
	AVS:Load()
	MenuHelper:LoadFromJsonFile(AVS._path .. "options.txt", AVS, AVS._settings)
end)
