--AntiVoiceSpamTwo:ProcessBlacklist()

local orig_say_voiceline = UnitNetworkHandler.say
function UnitNetworkHandler:say(unit,event_id,sender,...) --this function interprets/intercepts voice lines from other players
	if AntiVoiceSpamTwo:Enabled() then 
		if not alive(unit) or not self._verify_gamestate(self._gamestate_filter.any_ingame) or not self._verify_sender(sender) then
			return
		end
		local peer = self._verify_sender(sender)
		local id64 = peer:user_id()
		if peer then
			if managers.chat:is_peer_muted(peer) then --muted peer with ingame players list options
				return
			end
			if (not id64) or ((AntiVoiceSpamTwo:GetPlayerVOCooldown(id64) + AntiVoiceSpamTwo:GetVOCooldownSetting()) > Application:time()) then --peer is on cooldown
			--(t + cooldown_setting) represents next available cooldown setting for player (id)
				return 
			else
				AntiVoiceSpamTwo:SetPlayerVOCooldown(id64)
			end
		end
		if AntiVoiceSpamTwo:IsBanned(event_id) then --muted voiceline from blacklist
			return
		end
	end
	return orig_say_voiceline(self,unit,event_id,sender,...)
end

local orig_unit_sound_play = UnitNetworkHandler.unit_sound_play
function UnitNetworkHandler:unit_sound_play(unit, event_id, source, sender,...)
	if AntiVoiceSpamTwo:Enabled() then 
		local peer = sender and self._verify_sender(sender)
		if peer then
			local id64 = peer:user_id()
			if managers.chat:is_peer_muted(peer) then --muted peer with ingame players list options
				return
			end
	--[[ I think this function applies to non-player entities even though it's sent from the player, so i'll just have it check for banned lines and muted senders, and ignore the cooldown for this
	
			if (not id64) or ((AntiVoiceSpamTwo:GetPlayerVOCooldown(id64) + AntiVoiceSpamTwo:GetVOCooldownSetting()) > Application:time()) then
			--(t + cooldown_setting) represents next available cooldown setting for player (id)
				return 
			else
				AntiVoiceSpamTwo:SetPlayerVOCooldown(id64)
			end
			--]]
		end
		if AntiVoiceSpamTwo:IsBanned(event_id) then --muted voiceline from blacklist
			return
		end
	end
	return orig_unit_sound_play(self,unit,event_id,source,sender,...)
end